﻿cbuffer FONT_DESC:register(b0)
{
	float4 fontPosition[800];//xyuv
}

Texture2D FontMap;

SamplerState textureSampler
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

struct VS_INPUT
{
    float4 Position : POSITION;
};

struct PS_INPUT
{
    float4 Position : SV_POSITION;
    float2 TexCoord: TEXCOORD;
};

PS_INPUT VSMain( VS_INPUT input )
{
    PS_INPUT output = (PS_INPUT)0;
    output.Position=float4(fontPosition[input.Position.x].xy,0,1);
    output.TexCoord=fontPosition[input.Position.x].zw;
	return output;
}


float4 PSMain( PS_INPUT input) : SV_Target
{
	float4 c= FontMap.Sample( textureSampler, input.TexCoord);
	clip(c.w-0.1F);
	
	return 1;
	
		
}