﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ManagedDirectX.Direct3D11;
using ManagedDirectX.Direct3D11.Effect11;
using ManagedDirectX.Direct3D11.Resource11;
using ManagedDirectX.Direct3D11.Shader11;

namespace D3D11Helper
{
    public sealed class HelpFunction
    {


        public static ManagedDirectX.Direct3D11.Resource11.Buffer CreateConstantBuffer<T>(DeviceManager manager) where T : struct
        {
            BufferDescription cbDesc = new BufferDescription();
            cbDesc.ByteWidth = System.Runtime.InteropServices.Marshal.SizeOf(typeof(T));
            cbDesc.Usage = Usage.Dynamic;
            cbDesc.BindFlags = BindingFlag.ConstantBuffer;
            cbDesc.CPUAccessFlags = CPUAccessFlag.Write;
            cbDesc.MiscFlags = 0;

            return manager.DevicePointer.CreateBuffer(cbDesc);
        }


        public static ManagedDirectX.Direct3D11.Resource11.Buffer CreateConstantBuffer(DeviceManager manager, int size)
        {
            BufferDescription cbDesc = new BufferDescription();
            cbDesc.ByteWidth = size;
            cbDesc.Usage = Usage.Dynamic;
            cbDesc.BindFlags = BindingFlag.ConstantBuffer;
            cbDesc.CPUAccessFlags = CPUAccessFlag.Write;
            cbDesc.MiscFlags = 0;

            return manager.DevicePointer.CreateBuffer(cbDesc);
        }
    }
}
