﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ManagedDirectX.Direct3D11.Resource11;

namespace D3D11Helper
{
    

    /// <summary>
    /// Material
    /// </summary>
    public class Material3D 
    {
        /// <summary>
        /// Face count
        /// </summary>
        public int Attribute { get; set; }

        /// <summary>
        /// Texture
        /// </summary>
        public ShaderResourceView Texture { get; private set; }

        /// <summary>
        /// Construtor
        /// </summary>
        /// <param name="attribute">Attribute</param>
        /// <param name="filename">Filename</param>
        /// <param name="manager">Device manager</param>
        public Material3D(int attribute, string filename, DeviceManager manager)
        {
            Attribute = attribute;
            Texture = ShaderResourceView.CreateShaderResourceViewFromFile(manager.DevicePointer, filename);
        }

    }
}
